﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SORTER
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int[] array;
        string path;
        FileInfo file;
        Stopwatch linearTime;
        Stopwatch minMaxTime;
        Stopwatch bubleTime;
        Stopwatch shuttleTime;
        Stopwatch insertionTime;

        public MainWindow()
        {
            InitializeComponent();
        }


        void linearSelectionSort(bool? ordering)
        {
            List<int> arraySorted = new List<int>();
            int[] arrayCopy = new int[array.Length];

            int max = int.MinValue;
            int min = int.MaxValue;
            int index = 0;

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            string pathCopy = file.DirectoryName + @"\Линейная сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            linearTime = new Stopwatch();
            linearTime.Start();

            if (ordering == false)
            {
                using (StreamWriter sw = new StreamWriter(pathCopy, false))
                {
                    while (arraySorted.Count < 100)
                    {
                        for (int i = 0; i < arrayCopy.Length; ++i)
                        {
                            if (max <= arrayCopy[i] && arrayCopy[i] != 100)
                            {
                                max = arrayCopy[i];
                                index = i;
                            }
                        }
                        arrayCopy[index] = 100;
                        arraySorted.Add(max);
                        sw.Write(max + " ");
                        max = int.MinValue;
                    }
                }
            }
            else
            {
                using (StreamWriter sw = new StreamWriter(pathCopy, false))
                {
                    while (arraySorted.Count < 100)
                    {
                        for (int i = 0; i < arrayCopy.Length; ++i)
                        {
                            if (min >= arrayCopy[i] && arrayCopy[i] != 100)
                            {
                                min = arrayCopy[i];
                                index = i;
                            }
                        }
                        arrayCopy[index] = 100;
                        arraySorted.Add(min);
                        sw.Write(min + " ");
                        min = int.MaxValue;
                    }
                }
            }

            linearTime.Stop();

            arraySorted.Clear();
        }


        void methodMinMax(bool? ordering)
        {
            minMaxTime = new Stopwatch();
            minMaxTime.Start();

            if(ordering == false)
            {
                for (int i = 0; i < array.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j].CompareTo(array[max]) > 0)
                        {
                            max = j;
                        }
                    }

                    int temp = array[i];
                    array[i] = array[max];
                    array[max] = temp;
                }

            }
            else
            {
                for (int i = 0; i < array.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j].CompareTo(array[max]) < 0)
                        {
                            max = j;
                        }
                    }

                    int temp = array[i];
                    array[i] = array[max];
                    array[max] = temp;
                }

            }

            minMaxTime.Stop();

            string pathCopy = file.DirectoryName + @"\МинМакс.txt";
            if(!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            using (StreamWriter sw = new StreamWriter(pathCopy, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void BubbleSort(bool? ordering)
        {
            int temp;

            bubleTime = new Stopwatch();
            bubleTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < array.Length - 1; i++)
                {
                    for (int j = 0; j < array.Length - i - 1; j++)
                    {
                        if (array[j + 1] > array[j])
                        {
                            temp = array[j + 1];
                            array[j + 1] = array[j];
                            array[j] = temp;
                        }
                    }
                }
            }
            else
            {
                for (int i = 0; i < array.Length - 1; i++)
                {
                    for (int j = 0; j < array.Length - i - 1; j++)
                    {
                        if (array[j + 1] < array[j])
                        {
                            temp = array[j + 1];
                            array[j + 1] = array[j];
                            array[j] = temp;
                        }
                    }
                }
            }

            bubleTime.Stop();

            string pathCopy = file.DirectoryName + @"\Пузырьковая сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            using (StreamWriter sw = new StreamWriter(pathCopy, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void ShuttleSort(bool? ordering)
        {

            int temp;

            shuttleTime = new Stopwatch();
            shuttleTime.Start();

            if(ordering == false)
            {
                for (int i = 1; i < array.Length; i++)
                {
                    if (array[i] < array[i - 1])
                    {
                        temp = array[i];
                        array[i] = array[i - 1];
                        array[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (array[j] < array[j - 1])
                            {
                                temp = array[j];
                                array[j] = array[j - 1];
                                array[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }
            else
            {
                for (int i = 1; i < array.Length; i++)
                {
                    if (array[i] > array[i - 1])
                    {
                        temp = array[i];
                        array[i] = array[i - 1];
                        array[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (array[j] > array[j - 1])
                            {
                                temp = array[j];
                                array[j] = array[j - 1];
                                array[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }

            shuttleTime.Stop();

            string pathCopy = file.DirectoryName + @"\Челночная сортировка.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            using (StreamWriter sw = new StreamWriter(pathCopy, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void InsertionSort(bool? ordering)
        {

            int index, temp;

            insertionTime = new Stopwatch();
            insertionTime.Start();

            if (ordering == false)
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    index = i;
                    temp = array[i];
                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j] > temp)
                        {
                            index = j;
                            temp = array[j];
                        }
                    }
                    array[index] = array[i];
                    array[i] = temp;
                }
            }
            else
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    index = i;
                    temp = array[i];
                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j] < temp)
                        {
                            index = j;
                            temp = array[j];
                        }
                    }
                    array[index] = array[i];
                    array[i] = temp;
                }
            }

            insertionTime.Stop();

            string pathCopy = file.DirectoryName + @"\Сортировка вставки.txt";
            if (!File.Exists(pathCopy))
            {
                File.Copy(path, pathCopy);
            }

            using (StreamWriter sw = new StreamWriter(pathCopy, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }

        private void SortButton_Click(object sender, RoutedEventArgs e)
        {
            if(string.IsNullOrEmpty(path))
            {
                MessageBox.Show("Для сортировки нужно выбрать файл");
            }
            else
            {
                if (LinearButton.IsChecked == true)
                {
                    linearSelectionSort(Ascending.IsChecked);
                }
                else if (minMaxButton.IsChecked == true)
                {
                    methodMinMax(Ascending.IsChecked);
                }
                else if (BubbleButton.IsChecked == true)
                {
                    BubbleSort(Ascending.IsChecked);
                }
                else if (ShuttleButton.IsChecked == true)
                {
                    ShuttleSort(Ascending.IsChecked);
                }
                else if (InsertionButton.IsChecked == true)
                {
                    InsertionSort(Ascending.IsChecked);
                }
            }
        }

        private void SelectFile_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OPF = new OpenFileDialog();
            OPF.Filter = "Файлы txt|*.txt";
            if (OPF.ShowDialog() == true)
            {
                path = OPF.FileName;
                file = new FileInfo(path);

                using (StreamReader sr = new StreamReader(OPF.FileName))
                {
                    string str = sr.ReadToEnd().Trim();
                    string[] arrayStr = str.Split(" ");

                    array = new int[arrayStr.Length];

                    for (int i = 0; i < arrayStr.Length; ++i)
                    {
                        array[i] = Convert.ToInt32(arrayStr[i]);
                    }
                }
            }
        }

        private void Diagram_Click(object sender, RoutedEventArgs e)
        {
            if (linearTime == null || minMaxTime == null || bubleTime == null || shuttleTime == null || insertionTime == null)
            {
                MessageBox.Show("Для того, чтобы построить диаграмму, нужно отсортировать массив всемя способами");
            }
            else
            {
                Diagram wnd = new Diagram(linearTime.ElapsedTicks, minMaxTime.ElapsedTicks, bubleTime.ElapsedTicks, shuttleTime.ElapsedTicks, insertionTime.ElapsedTicks);
                wnd.Show();
            }
        }
    }
}
